SystemOrganization addCategory: #ConfigurationFiles!

Object subclass: #ConfigurationFiles
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ConfigurationFiles'!

ConfigurationFiles class
	instanceVariableNames: 'configurations'!

!ConfigurationFiles commentStamp: 'sebastiansastre 1/5/2013 14:38' prior: 0!
A ConfigurationFiles is a helper to access the configuration files expected to be in the conf subdirectory of this image. 

The configuration files are expected to be .conf files containing smalltalk code (usually a dictionary).

The rest is responsibility of the applications using it

!

ConfigurationFiles class
	instanceVariableNames: 'configurations'!

!ConfigurationFiles class methodsFor: 'accessing' stamp: 'sebastiansastre 10/1/2012 23:13'!
at: aConfKey at: aKey

	^ (self configurations at: aConfKey) at: aKey! !

!ConfigurationFiles class methodsFor: 'accessing' stamp: 'sebastiansastre 6/6/2013 16:54'!
confFiles

	^ (FSLocator imageDirectory / 'conf') resolve allFiles select:[:e|
		e extension = 'conf']
	 ! !

!ConfigurationFiles class methodsFor: 'actions' stamp: 'sebastiansastre 10/1/2012 20:19'!
confFrom: aFilename

	^ aFilename asReference readStreamDo:[:stream| |source|
		source := stream contents.
		[Compiler evaluate: source] on: Error do:[:x| 'configuration error']]! !

!ConfigurationFiles class methodsFor: 'accessing' stamp: 'sebastiansastre 10/1/2012 19:52'!
configurations

	^ configurations ifNil:[self initializeConfigurations]! !

!ConfigurationFiles class methodsFor: 'initialization' stamp: 'sebastiansastre 10/1/2012 20:03'!
initializeConfigurations

	^ configurations := self makeConfigurations! !

!ConfigurationFiles class methodsFor: 'actions' stamp: 'sebastiansastre 10/1/2012 20:12'!
keyFrom: aFilename

	^ aFilename basename readStream upTo: $. ! !

!ConfigurationFiles class methodsFor: 'actions' stamp: 'sebastiansastre 10/1/2012 20:20'!
makeConfigurations

	^ [:dic|
		self confFiles do:[:filename|
			dic 
				at: (self keyFrom: filename) 
				put: (self confFrom: filename)].
		dic] value: Dictionary new! !

!ConfigurationFiles class methodsFor: 'actions' stamp: 'sebastiansastre 10/1/2012 19:52'!
reset 

	configurations := nil! !
